--- asterisk/channels/chan_zap.c	9 Jun 2004 13:55:52 -0000	1.261
+++ asterisk/channels/chan_zap.c	10 Jun 2004 18:43:06 -0000
@@ -4403,6 +4403,7 @@
 	switch(p->sig) {
 #ifdef ZAPATA_PRI
 	case SIG_PRI:
+		res = tone_zone_play_tone(p->subs[index].zfd, ZT_TONE_DIALTONE);
 		/* Now loop looking for an extension */
 		strncpy(exten, p->exten, sizeof(exten) - 1);
 		len = strlen(exten);
@@ -4419,9 +4420,14 @@
 				return NULL;
 			} else if (res) {
 				exten[len++] = res;
+				if (!ast_ignore_pattern(chan->context, exten))
+					tone_zone_play_tone(p->subs[index].zfd, -1);
+				else
+					tone_zone_play_tone(p->subs[index].zfd, ZT_TONE_DIALTONE);
 			} else
 				break;
 		}
+		tone_zone_play_tone(p->subs[index].zfd, -1);
 		if (ast_exists_extension(chan, chan->context, exten, 1, p->callerid)) {
 			/* Start the real PBX */
 			strncpy(chan->exten, exten, sizeof(chan->exten));
@@ -4431,6 +4437,7 @@
 				ast_log(LOG_WARNING, "PBX exited non-zero!\n");
 			}
 		} else {
+			tone_zone_play_tone(p->subs[index].zfd, -1);
 			ast_log(LOG_DEBUG, "No such possible extension '%s' in context '%s'\n", exten, chan->context);
 			chan->hangupcause = AST_CAUSE_UNALLOCATED;
 			ast_hangup(chan);
